/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#define HARMONICS 11

void value_changed(GtkAdjustment *adjustment, gpointer user_data);
void changed(GtkEditable *editable, gpointer user_data);
void focus_out(GtkWidget *widget, GdkEventFocus *event, gpointer user_data);
void chebpc(float c[], float d[]);
void calc_and_draw();

GtkWidget *text[10];
GtkAdjustment *adj[10];
GtkWidget *draw;
int curve[129];
float mag[11], p[11];

int main (int argc, char *argv[])
{
  GtkWidget *window1;
  unsigned int i;
  GtkWidget *slider;
  char name[256];
  char tval[256];

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  window1 = create_window1 ();
  for (i=0; i<10; i++) {
    sprintf(name, "vscale%u", i+1);
    slider = lookup_widget(window1, name);
    adj[i] = gtk_range_get_adjustment(GTK_RANGE(slider));
    gtk_signal_connect (GTK_OBJECT (adj[i]), "value-changed",
                        GTK_SIGNAL_FUNC (value_changed),
                        (gpointer)i);

    sprintf(name, "entry%u", i+1);
    text[i] = lookup_widget(window1, name);
    sprintf(tval, "%+f", -adj[i]->value);
    gtk_entry_set_text(GTK_ENTRY(text[i]), tval);

    gtk_signal_connect (GTK_OBJECT (text[i]), "activate",
                        GTK_SIGNAL_FUNC (changed),
                        (gpointer)i);
    gtk_signal_connect (GTK_OBJECT (text[i]), "focus_out_event",
                        GTK_SIGNAL_FUNC (focus_out),
                        (gpointer)i);
    draw = lookup_widget(window1, "drawingarea1");
  }
  
  gtk_widget_show (window1);

  calc_and_draw();

  gtk_main ();

  return 0;
}

void value_changed(GtkAdjustment *adjustment, gpointer user_data)
{
	int port = (int)user_data;
	float val = -adjustment->value;
	char tval[256];

	sprintf(tval, "%+f", val);
	gtk_entry_set_text(GTK_ENTRY(text[port]), tval);
	printf("port %d = %f\n", port, val);

	calc_and_draw();
}

void calc_and_draw()
{
	int i;
	float mag_fix = 0.0f;

        mag[0] = 0.0f;
        for (i=0; i<10; i++) {
		mag[i+1] = adj[i]->value;
		mag_fix += fabs(mag[i+1]);
	}
        if (mag_fix < 1.0f) {
          mag_fix = 64.0f;
        } else {
          mag_fix = 64.0f / mag_fix;
        }

	chebpc(mag, p);

	for (i=0; i<129; i++) {
		float x = sin(i * 0.05);
		curve[i] = (p[0] + (p[1] + (p[2] + (p[3] + (p[4] + (p[5] + (p[6] + (p[7] +
            (p[8] + (p[9] + p[10] * x) * x) * x) * x) * x) * x) * x) * x) *
            x) * x) * mag_fix + 64;
	}

	gtk_widget_queue_draw(draw);
}

void changed(GtkEditable *editable, gpointer user_data)
{
	int port = (int)user_data;
	gtk_adjustment_set_value(adj[port], -atof(gtk_editable_get_chars(editable, 0, -1)));
}

void focus_out(GtkWidget *widget, GdkEventFocus *event, gpointer user_data) {
	changed(GTK_EDITABLE(widget), user_data);
}

void chebpc(float c[], float d[])
{
    int k, j;
    float sv, dd[HARMONICS];

    for (j = 0; j < HARMONICS; j++) {
        d[j] = dd[j] = 0.0;
    }

    d[0] = c[HARMONICS - 1];

    for (j = HARMONICS - 2; j >= 1; j--) {
        for (k = HARMONICS - j; k >= 1; k--) {
            sv = d[k];
            d[k] = 2.0 * d[k - 1] - dd[k];
            dd[k] = sv;
        }
        sv = d[0];
        d[0] = -dd[0] + c[j];
        dd[0] = sv;
    }

    for (j = HARMONICS - 1; j >= 1; j--) {
        d[j] = d[j - 1] - dd[j];
    }
    d[0] = -dd[0] + 0.5 * c[0];
}

